Attribute VB_Name = "Module2"
Option Explicit
Private col1() As String
Private col3() As String
Private OutGrid_initialized As Boolean


Function FillStringArray(ParamArray a()) As String()
Dim b() As String
ReDim b(LBound(a) To UBound(a)) As String
Dim i As Integer
    For i = LBound(a) To UBound(a)
        b(i) = a(i)
    Next i
    FillStringArray = b
End Function


Sub FillCol1Col3()
col1 = FillStringArray("UB", "FCW", "UA", "U100", "USTCWS", "USTCW", "Z0", "FALL", "RHEIGHT", "RLENGTH", "C0A", "QS", "QSDIR", "SEDM", "SED", "SEDDIR", "AB", "WL", "USTCRB", "USTCRS", "USTUP", "Z0C", "PHIB", "PHI100", "DELTACW", "USTCS", "USTWS", _
    "USTCWSE", "USTCWSB", "USTC", "USTW", "RPLCOEF", "TB1", "TB2", "TS1", "TS2", "PERBED", "PERSUSP", "C0", "TAOCWS", "RHOW", "VISC")
col3 = FillStringArray( _
    "maximum wave induced orbital velocity at the bottom (m/s)", "bottom (skin) friction factor", _
    "current speed to be used in bottom stress calc. (m/sec)", "current speed at 1 m above seabed (m/sec)", _
    "combined skin-friction shear velocity of GM (m/sec)", "combined total shear velocity of GM (m/sec)", _
    "bed roughness length (m)", "settling velocity for non-cohesive sediment (m/sec)", _
    "predicted ripple height (m)", "predicted ripple length (m)", _
    "depth averaged reference concentration at z0 (kg/m^3)", _
    "suspended sediment transport rate (kg/m/s)", "direction of suspended sediment transport (degree)", _
    "time-averaged net sediment transport as mass (kg/s/m)", _
    "time-averaged net sediment transport as volume (m**3/s/m)", _
    "direction of net sediment transport (azimuth,degrees)", _
    "excursion length of bottom wave orbit (m)", "wave length (m)", _
    "critical shear vel for initi of bedload trans (m/sec)", "critical shear vel for initi of suspended load transport (m/sec)", _
    "critical shear vel for initn of sheet flow transport (m/sec)", "apparent bed roughness length (m)", _
    "angle between wave and current directions (radians)", "angle between wave and current directions at 1 m above seabed (radians)", _
    "height of the wave-current boundary layer (m)", "current skin-friction shear velocity of GM (m/sec)", _
    "wave skin-friction shear velocity of GM (m/sec)", "effective combined skin-friction shear velocity (m/sec)", _
    "transport-related combined shear velocity (m/sec)", "total current shear velocity of GM (m/sec)", _
    "total wave shear velocity of GM (m/sec)", "ripple coefficient for shear velocity conversion", _
    "time at which bedload transport ceases (sec)", "time at which bedload transport recommences (sec)", _
    "time at which suspended load transport ceases (sec)", "time at which suspended load transport recommences (sec)", _
    "percentage of time spent in only bedload transport phase", "percentage of time spent in suspended load transport phase", _
    "reference concentration at z0 (kg/m^3)", "averaged effective shear stress (Pa)", _
    "water density (kg/m3)", "dynamic viscosity of water (Pa s)")
End Sub


Sub FillOutGrid(Col_2_empty As Boolean)
Dim i As Integer
If Col_2_empty < 10 And Not OutGrid_initialized Then    ' start of Sedtrans05
    Call FillCol1Col3
    For i = LBound(col1) To UBound(col1)
        Fmain.OutGrid.AddItem (col1(i) & vbTab & "" & vbTab & col3(i))
    Next i
    Fmain.OutGrid.TextMatrix(0, 0) = " "
    Fmain.OutGrid.TextMatrix(0, 1) = " "
    Fmain.OutGrid.TextMatrix(0, 2) = " "
    OutGrid_initialized = True
ElseIf Col_2_empty Then                     ' empty column 2
    For i = 1 To UBound(col1) + 1
        Fmain.OutGrid.TextMatrix(i, 1) = ""
    Next i
Else                                        ' fill column 2 with results
    For i = 1 To UBound(col1) + 1
        If i <= 16 Then
            Fmain.OutGrid.TextMatrix(i, 1) = FormatN(Data(PosData).out1(i), 7, 4)
        Else
            Fmain.OutGrid.TextMatrix(i, 1) = FormatN(Data(PosData).out2(i - 16), 7, 4)
        End If
    Next i
End If
End Sub


Function FormatN(value, length, nb_significatif) As String
Dim x, a
Dim ch As String, ch2 As String, ch_e As String
Dim pos_e As Integer

If value = 0 Then
    FormatN = "0"
    Exit Function
End If

x = Int(Log(Abs(value)) / Log(10))
If x >= length Then
    ch = "0." & String(nb_significatif - 1, "0") & "e+00"
ElseIf nb_significatif - x > length Then
    ch = "0." & String(nb_significatif - 1, "0") & "e+00"
ElseIf Abs(value) >= 1 Then
    ch = String(x + 1, "0")
    a = x + 1 - nb_significatif
    If Log(Abs(value)) / Log(10) - x < 0.301 Then a = a - 1
    If a < 0 Then ch = ch & "." & String(-a, "0")
Else
    ch = "0." & String(-x + nb_significatif - 1, "0")
End If

ch2 = Format(value, ch)

pos_e = InStr(ch2, "e")
If pos_e > 0 Then
    ch_e = Mid(ch2, pos_e)
    ch2 = Left(ch2, pos_e - 1)
Else
    ch_e = ""
End If
If InStr(ch2, ".") > 0 Then
    While Right(ch2, 1) = "0"
        ch2 = Left(ch2, Len(ch2) - 1)
    Wend
    If Right(ch2, 1) = "." Then ch2 = Left(ch2, Len(ch2) - 1)
End If
FormatN = ch2 & ch_e
End Function


' if all_grid is true, copy all the cells of the indicated MSFlexGrid in the clipboard,
' otherwise copy only the selected cells
Sub Copy_FlexGrid(source As MSFlexGrid, all_grid As Boolean)
Dim ch As String
Dim c1 As Long, c2 As Long, r1 As Long, r2 As Long
Dim i As Long, j As Long
    If all_grid Then
        c1 = 0
        c2 = source.Cols - 1
        r1 = 0
        r2 = source.Rows - 1
    Else
        c1 = source.col
        c2 = source.ColSel
        If c1 > c2 Then
            i = c1
            c1 = c2
            c2 = i
        End If
        r1 = source.Row
        r2 = source.RowSel
        If r1 > r2 Then
            i = r1
            r1 = r2
            r2 = i
        End If
        If c1 = source.FixedCols And c2 = source.Cols - 1 Then
            c1 = 0
        End If
        If r1 = source.FixedRows And r2 = source.Rows - 1 Then
            r1 = 0
        End If
    End If
    ch = ""
    For i = r1 To r2
        For j = c1 To c2
            ch = ch & source.TextMatrix(i, j)
            If j < c2 Then
                ch = ch & vbTab
            End If
        Next j
        If i < r2 Then
            ch = ch & vbNewLine
        End If
    Next i
    Clipboard.Clear
    Clipboard.SetText ch
End Sub

Sub DecomposeFileName(Fullpath, Directory, FileName, Optional ShortName, Optional Extension)
Dim pos1 As Integer ' position of dot
Dim pos2 As Integer ' position of backslash

pos1 = InStrRev(Fullpath, ".")
pos2 = InStrRev(Fullpath, "\")
If pos2 < 0 Then pos2 = 0
If pos2 = 0 And Mid(Fullpath, 2, 1) = ":" Then pos2 = 2
If pos1 < pos2 Then pos1 = 0

If pos2 <= 1 Then
    Directory = ""
Else
    Directory = Left(Fullpath, pos2 - 1)
End If
FileName = Mid(Fullpath, pos2 + 1)
If Not IsMissing(ShortName) Then
    If pos1 < 1 Then
        ShortName = Mid(Fullpath, pos2 + 1)
    Else
        ShortName = Mid(Fullpath, pos2 + 1, pos1 - pos2 - 1)
    End If
End If
If Not IsMissing(Extension) Then
    If pos1 < 1 Then
        Extension = ""
    Else
        Extension = Mid(Fullpath, pos1 + 1)
    End If
End If
End Sub

Function FilenameDirectory(Fullpath As String) As String
Dim ch1 As String, ch2 As String
    Call DecomposeFileName(Fullpath, ch1, ch2)
    FilenameDirectory = ch1
End Function
Function FilenameFull(Fullpath As String) As String
Dim ch1 As String, ch2 As String
    Call DecomposeFileName(Fullpath, ch1, ch2)
    FilenameFull = ch2
End Function
Function FilenameShort(Fullpath As String) As String
Dim ch1 As String, ch2 As String, ch3 As String
    Call DecomposeFileName(Fullpath, ch1, ch2, ch3)
    FilenameShort = ch3
End Function
Function FilenameExtension(Fullpath As String) As String
Dim ch1 As String, ch2 As String, ch3 As String, ch4 As String
    Call DecomposeFileName(Fullpath, ch1, ch2, ch3, ch4)
    FilenameExtension = ch4
End Function

